% CRFLEARNTEST
% Stephen Gould <sgould@stanford.edu>

addpath('../../../bin');

% construct CRF model
model.weights = zeros(6, 1);

model.templates(1).cards = [2];
model.templates(1).entries(1).wi = [0];
model.templates(1).entries(1).xi = [-1];
model.templates(1).entries(2).wi = [1];
model.templates(1).entries(2).xi = [-1];

model.templates(2).cards = [2 2];
model.templates(2).entries(1).wi = [2];
model.templates(2).entries(1).xi = [-1];
model.templates(2).entries(2).wi = [3];
model.templates(2).entries(2).xi = [-1];
model.templates(2).entries(3).wi = [3];
model.templates(2).entries(3).xi = [-1];
model.templates(2).entries(4).wi = [2];
model.templates(2).entries(4).xi = [-1];

model.templates(3).cards = [2 2];
model.templates(3).entries(1).wi = [4];
model.templates(3).entries(1).xi = [-1];
model.templates(3).entries(2).wi = [5];
model.templates(3).entries(2).xi = [-1];
model.templates(3).entries(3).wi = [5];
model.templates(3).entries(3).xi = [-1];
model.templates(3).entries(4).wi = [4];
model.templates(3).entries(4).xi = [-1];

% construct base CRF instance
instance.nodes = repmat(struct('Yn', -1, 'Kn', 2), 4, 1);
for i = 1:4,
  instance.cliques(i).Cm = [i - 1];
  instance.cliques(i).Xm = [];
  instance.cliques(i).Tm = 0;
end;
for i = 1:3,
  instance.cliques(4 + i).Cm = [i - 1, i];
  instance.cliques(4 + i).Xm = [];
  instance.cliques(4 + i).Tm = 1;
end;
instance.cliques(8).Cm = [3, 0];
instance.cliques(8).Xm = [];
instance.cliques(8).Tm = 2;

% construct CRF instances
instances = repmat(instance, 100, 1);
for i = 1:size(instances, 1),
  y = rand(length(instances(i).nodes), 1) + 0.1 * (0:3)';
  y(y < 0.25) = 0; y(y > 0) = 1;
  for j = 1:length(instances(i).nodes),
    instances(i).nodes(j).Yn = y(j);
  end;
end;

% run training
model = mexCRFLearn(model, instances, 1000, 0.001);
model.weights
